/* util-avatar.c generated by valac 0.42.6, the Vala compiler
 * generated from util-avatar.vala, do not modify */

/*
 * Copyright 2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <pango/pangocairo.h>

#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))



GdkPixbuf* util_avatar_generate_user_picture (const gchar* name,
                                              gint size);
void util_avatar_get_color_for_name (const gchar* name,
                                     GdkRGBA* result);
gchar* util_avatar_extract_initials_from_name (const gchar* name);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
GdkPixbuf* util_avatar_round_image (GdkPixbuf* source);


static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 37 "../src/client/util/util-avatar.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 48 "util-avatar.c"
}


GdkPixbuf*
util_avatar_generate_user_picture (const gchar* name,
                                   gint size)
{
	GdkPixbuf* result = NULL;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	GdkRGBA color = {0};
	GdkRGBA _tmp4_ = {0};
	cairo_t* _tmp5_;
	GdkRGBA _tmp6_;
	gdouble _tmp7_;
	GdkRGBA _tmp8_;
	gdouble _tmp9_;
	GdkRGBA _tmp10_;
	gdouble _tmp11_;
	cairo_t* _tmp12_;
	gchar* initials = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	cairo_surface_t* _tmp34_;
	GdkPixbuf* _tmp35_;
#line 15 "../src/client/util/util-avatar.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 16 "../src/client/util/util-avatar.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 16 "../src/client/util/util-avatar.vala"
	surface = _tmp0_;
#line 19 "../src/client/util/util-avatar.vala"
	_tmp1_ = surface;
#line 19 "../src/client/util/util-avatar.vala"
	_tmp2_ = cairo_create (_tmp1_);
#line 19 "../src/client/util/util-avatar.vala"
	cr = _tmp2_;
#line 20 "../src/client/util/util-avatar.vala"
	_tmp3_ = cr;
#line 20 "../src/client/util/util-avatar.vala"
	cairo_rectangle (_tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) size, (gdouble) size);
#line 23 "../src/client/util/util-avatar.vala"
	util_avatar_get_color_for_name (name, &_tmp4_);
#line 23 "../src/client/util/util-avatar.vala"
	color = _tmp4_;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp5_ = cr;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp6_ = color;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp7_ = _tmp6_.red;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp8_ = color;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp9_ = _tmp8_.green;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp10_ = color;
#line 24 "../src/client/util/util-avatar.vala"
	_tmp11_ = _tmp10_.blue;
#line 24 "../src/client/util/util-avatar.vala"
	cairo_set_source_rgb (_tmp5_, _tmp7_ / 255.0, _tmp9_ / 255.0, _tmp11_ / 255.0);
#line 27 "../src/client/util/util-avatar.vala"
	_tmp12_ = cr;
#line 27 "../src/client/util/util-avatar.vala"
	cairo_fill (_tmp12_);
#line 30 "../src/client/util/util-avatar.vala"
	_tmp13_ = util_avatar_extract_initials_from_name (name);
#line 30 "../src/client/util/util-avatar.vala"
	initials = _tmp13_;
#line 31 "../src/client/util/util-avatar.vala"
	_tmp14_ = initials;
#line 31 "../src/client/util/util-avatar.vala"
	if (_tmp14_ != NULL) {
#line 126 "util-avatar.c"
		gchar* font = NULL;
		gchar* _tmp15_;
		cairo_t* _tmp16_;
		PangoLayout* layout = NULL;
		cairo_t* _tmp17_;
		PangoLayout* _tmp18_;
		PangoLayout* _tmp19_;
		const gchar* _tmp20_;
		PangoLayout* _tmp21_;
		const gchar* _tmp22_;
		PangoFontDescription* _tmp23_;
		PangoFontDescription* _tmp24_;
		gint width = 0;
		gint height = 0;
		PangoLayout* _tmp25_;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		cairo_t* _tmp28_;
		cairo_t* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		cairo_t* _tmp32_;
		PangoLayout* _tmp33_;
#line 32 "../src/client/util/util-avatar.vala"
		_tmp15_ = g_strdup_printf ("Sans %d", (gint) ceil (size / 2.5));
#line 32 "../src/client/util/util-avatar.vala"
		font = _tmp15_;
#line 34 "../src/client/util/util-avatar.vala"
		_tmp16_ = cr;
#line 34 "../src/client/util/util-avatar.vala"
		cairo_set_source_rgb (_tmp16_, 1.0, 1.0, 1.0);
#line 35 "../src/client/util/util-avatar.vala"
		_tmp17_ = cr;
#line 35 "../src/client/util/util-avatar.vala"
		_tmp18_ = pango_cairo_create_layout (_tmp17_);
#line 35 "../src/client/util/util-avatar.vala"
		layout = _tmp18_;
#line 36 "../src/client/util/util-avatar.vala"
		_tmp19_ = layout;
#line 36 "../src/client/util/util-avatar.vala"
		_tmp20_ = initials;
#line 36 "../src/client/util/util-avatar.vala"
		pango_layout_set_text (_tmp19_, _tmp20_, -1);
#line 37 "../src/client/util/util-avatar.vala"
		_tmp21_ = layout;
#line 37 "../src/client/util/util-avatar.vala"
		_tmp22_ = font;
#line 37 "../src/client/util/util-avatar.vala"
		_tmp23_ = pango_font_description_from_string (_tmp22_);
#line 37 "../src/client/util/util-avatar.vala"
		_tmp24_ = _tmp23_;
#line 37 "../src/client/util/util-avatar.vala"
		pango_layout_set_font_description (_tmp21_, _tmp24_);
#line 37 "../src/client/util/util-avatar.vala"
		__vala_PangoFontDescription_free0 (_tmp24_);
#line 40 "../src/client/util/util-avatar.vala"
		_tmp25_ = layout;
#line 40 "../src/client/util/util-avatar.vala"
		pango_layout_get_size (_tmp25_, &_tmp26_, &_tmp27_);
#line 40 "../src/client/util/util-avatar.vala"
		width = _tmp26_;
#line 40 "../src/client/util/util-avatar.vala"
		height = _tmp27_;
#line 41 "../src/client/util/util-avatar.vala"
		_tmp28_ = cr;
#line 41 "../src/client/util/util-avatar.vala"
		cairo_translate (_tmp28_, (gdouble) (size / 2), (gdouble) (size / 2));
#line 42 "../src/client/util/util-avatar.vala"
		_tmp29_ = cr;
#line 42 "../src/client/util/util-avatar.vala"
		_tmp30_ = width;
#line 42 "../src/client/util/util-avatar.vala"
		_tmp31_ = height;
#line 42 "../src/client/util/util-avatar.vala"
		cairo_move_to (_tmp29_, (-(((gdouble) _tmp30_) / PANGO_SCALE)) / 2, (-(((gdouble) _tmp31_) / PANGO_SCALE)) / 2);
#line 46 "../src/client/util/util-avatar.vala"
		_tmp32_ = cr;
#line 46 "../src/client/util/util-avatar.vala"
		_tmp33_ = layout;
#line 46 "../src/client/util/util-avatar.vala"
		pango_cairo_show_layout (_tmp32_, _tmp33_);
#line 31 "../src/client/util/util-avatar.vala"
		_g_object_unref0 (layout);
#line 31 "../src/client/util/util-avatar.vala"
		_g_free0 (font);
#line 212 "util-avatar.c"
	}
#line 49 "../src/client/util/util-avatar.vala"
	_tmp34_ = surface;
#line 49 "../src/client/util/util-avatar.vala"
	_tmp35_ = gdk_pixbuf_get_from_surface (_tmp34_, 0, 0, size, size);
#line 49 "../src/client/util/util-avatar.vala"
	result = _tmp35_;
#line 49 "../src/client/util/util-avatar.vala"
	_g_free0 (initials);
#line 49 "../src/client/util/util-avatar.vala"
	_cairo_destroy0 (cr);
#line 49 "../src/client/util/util-avatar.vala"
	_cairo_surface_destroy0 (surface);
#line 49 "../src/client/util/util-avatar.vala"
	return result;
#line 228 "util-avatar.c"
}


GdkPixbuf*
util_avatar_round_image (GdkPixbuf* source)
{
	GdkPixbuf* result = NULL;
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 54 "../src/client/util/util-avatar.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (source), NULL);
#line 55 "../src/client/util/util-avatar.vala"
	_tmp0_ = gdk_pixbuf_get_width (source);
#line 55 "../src/client/util/util-avatar.vala"
	_tmp1_ = _tmp0_;
#line 55 "../src/client/util/util-avatar.vala"
	size = _tmp1_;
#line 56 "../src/client/util/util-avatar.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 56 "../src/client/util/util-avatar.vala"
	surface = _tmp2_;
#line 59 "../src/client/util/util-avatar.vala"
	_tmp3_ = cairo_create (surface);
#line 59 "../src/client/util/util-avatar.vala"
	cr = _tmp3_;
#line 62 "../src/client/util/util-avatar.vala"
	cairo_arc (cr, (gdouble) (size / 2), (gdouble) (size / 2), (gdouble) (size / 2), (gdouble) 0, 2 * G_PI);
#line 63 "../src/client/util/util-avatar.vala"
	cairo_clip (cr);
#line 64 "../src/client/util/util-avatar.vala"
	cairo_new_path (cr);
#line 66 "../src/client/util/util-avatar.vala"
	gdk_cairo_set_source_pixbuf (cr, source, (gdouble) 0, (gdouble) 0);
#line 67 "../src/client/util/util-avatar.vala"
	cairo_paint (cr);
#line 69 "../src/client/util/util-avatar.vala"
	_tmp4_ = gdk_pixbuf_get_from_surface (surface, 0, 0, size, size);
#line 69 "../src/client/util/util-avatar.vala"
	result = _tmp4_;
#line 69 "../src/client/util/util-avatar.vala"
	_cairo_destroy0 (cr);
#line 69 "../src/client/util/util-avatar.vala"
	_cairo_surface_destroy0 (surface);
#line 69 "../src/client/util/util-avatar.vala"
	return result;
#line 280 "util-avatar.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 305 "util-avatar.c"
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1201 "glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 325 "util-avatar.c"
		gchar* _tmp1_;
#line 1202 "glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 337 "util-avatar.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 341 "util-avatar.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 349 "util-avatar.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 353 "util-avatar.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 359 "util-avatar.c"
	}
}


static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1111 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1112 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1112 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1114 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1114 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 383 "util-avatar.c"
		gchar* _tmp2_;
#line 1115 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1115 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1115 "glib-2.0.vapi"
		return result;
#line 391 "util-avatar.c"
	} else {
#line 1117 "glib-2.0.vapi"
		result = -1;
#line 1117 "glib-2.0.vapi"
		return result;
#line 397 "util-avatar.c"
	}
}


static guint8*
g_string_get_data (GString* self,
                   int* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	gssize _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 4987 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4988 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 4988 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 4988 "glib-2.0.vapi"
	res_length1 = -1;
#line 4988 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 4989 "glib-2.0.vapi"
	_tmp1_ = self->len;
#line 4989 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 4990 "glib-2.0.vapi"
	_tmp2_ = res;
#line 4990 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 4990 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 4990 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 4990 "glib-2.0.vapi"
	if (result_length1) {
#line 4990 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 442 "util-avatar.c"
	}
#line 4990 "glib-2.0.vapi"
	result = _tmp3_;
#line 4990 "glib-2.0.vapi"
	return result;
#line 448 "util-avatar.c"
}


gchar*
util_avatar_extract_initials_from_name (const gchar* name)
{
	gchar* result = NULL;
	gchar* normalized = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* initials = NULL;
	const gchar* _tmp6_;
#line 74 "../src/client/util/util-avatar.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp0_ = string_strip (name);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/client/util/util-avatar.vala"
	_tmp2_ = g_utf8_strup (_tmp1_, (gssize) -1);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp3_ = _tmp2_;
#line 75 "../src/client/util/util-avatar.vala"
	_tmp4_ = g_utf8_normalize (_tmp3_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 75 "../src/client/util/util-avatar.vala"
	_tmp5_ = _tmp4_;
#line 75 "../src/client/util/util-avatar.vala"
	_g_free0 (_tmp3_);
#line 75 "../src/client/util/util-avatar.vala"
	_g_free0 (_tmp1_);
#line 75 "../src/client/util/util-avatar.vala"
	normalized = _tmp5_;
#line 76 "../src/client/util/util-avatar.vala"
	initials = NULL;
#line 77 "../src/client/util/util-avatar.vala"
	_tmp6_ = normalized;
#line 77 "../src/client/util/util-avatar.vala"
	if (g_strcmp0 (_tmp6_, "") != 0) {
#line 491 "util-avatar.c"
		GString* buf = NULL;
		GString* _tmp7_;
		gunichar c = 0U;
		gint index = 0;
		const gchar* _tmp16_;
		GString* _tmp25_;
		guint8* _tmp26_;
		gint _tmp26__length1;
		guint8* _tmp27_;
		gint _tmp27__length1;
#line 78 "../src/client/util/util-avatar.vala"
		_tmp7_ = g_string_new ("");
#line 78 "../src/client/util/util-avatar.vala"
		buf = _tmp7_;
#line 79 "../src/client/util/util-avatar.vala"
		c = (gunichar) 0;
#line 80 "../src/client/util/util-avatar.vala"
		index = 0;
#line 510 "util-avatar.c"
		{
			gint i = 0;
#line 83 "../src/client/util/util-avatar.vala"
			i = 0;
#line 515 "util-avatar.c"
			{
				gboolean _tmp8_ = FALSE;
#line 83 "../src/client/util/util-avatar.vala"
				_tmp8_ = TRUE;
#line 83 "../src/client/util/util-avatar.vala"
				while (TRUE) {
#line 522 "util-avatar.c"
					const gchar* _tmp10_;
					gunichar _tmp11_ = 0U;
					gboolean _tmp12_;
					gunichar _tmp13_;
#line 83 "../src/client/util/util-avatar.vala"
					if (!_tmp8_) {
#line 529 "util-avatar.c"
						gint _tmp9_;
#line 83 "../src/client/util/util-avatar.vala"
						_tmp9_ = i;
#line 83 "../src/client/util/util-avatar.vala"
						i = _tmp9_ + 1;
#line 535 "util-avatar.c"
					}
#line 83 "../src/client/util/util-avatar.vala"
					_tmp8_ = FALSE;
#line 83 "../src/client/util/util-avatar.vala"
					_tmp10_ = normalized;
#line 83 "../src/client/util/util-avatar.vala"
					_tmp12_ = string_get_next_char (_tmp10_, &index, &_tmp11_);
#line 83 "../src/client/util/util-avatar.vala"
					c = _tmp11_;
#line 83 "../src/client/util/util-avatar.vala"
					if (!_tmp12_) {
#line 83 "../src/client/util/util-avatar.vala"
						break;
#line 549 "util-avatar.c"
					}
#line 84 "../src/client/util/util-avatar.vala"
					_tmp13_ = c;
#line 84 "../src/client/util/util-avatar.vala"
					if (g_unichar_isalnum (_tmp13_)) {
#line 555 "util-avatar.c"
						GString* _tmp14_;
						gunichar _tmp15_;
#line 85 "../src/client/util/util-avatar.vala"
						_tmp14_ = buf;
#line 85 "../src/client/util/util-avatar.vala"
						_tmp15_ = c;
#line 85 "../src/client/util/util-avatar.vala"
						g_string_append_unichar (_tmp14_, _tmp15_);
#line 86 "../src/client/util/util-avatar.vala"
						break;
#line 566 "util-avatar.c"
					}
				}
			}
		}
#line 91 "../src/client/util/util-avatar.vala"
		_tmp16_ = normalized;
#line 91 "../src/client/util/util-avatar.vala"
		index = string_last_index_of_char (_tmp16_, (gunichar) ' ', 0);
#line 575 "util-avatar.c"
		{
			gint i = 0;
#line 92 "../src/client/util/util-avatar.vala"
			i = 0;
#line 580 "util-avatar.c"
			{
				gboolean _tmp17_ = FALSE;
#line 92 "../src/client/util/util-avatar.vala"
				_tmp17_ = TRUE;
#line 92 "../src/client/util/util-avatar.vala"
				while (TRUE) {
#line 587 "util-avatar.c"
					const gchar* _tmp19_;
					gunichar _tmp20_ = 0U;
					gboolean _tmp21_;
					gunichar _tmp22_;
#line 92 "../src/client/util/util-avatar.vala"
					if (!_tmp17_) {
#line 594 "util-avatar.c"
						gint _tmp18_;
#line 92 "../src/client/util/util-avatar.vala"
						_tmp18_ = i;
#line 92 "../src/client/util/util-avatar.vala"
						i = _tmp18_ + 1;
#line 600 "util-avatar.c"
					}
#line 92 "../src/client/util/util-avatar.vala"
					_tmp17_ = FALSE;
#line 92 "../src/client/util/util-avatar.vala"
					_tmp19_ = normalized;
#line 92 "../src/client/util/util-avatar.vala"
					_tmp21_ = string_get_next_char (_tmp19_, &index, &_tmp20_);
#line 92 "../src/client/util/util-avatar.vala"
					c = _tmp20_;
#line 92 "../src/client/util/util-avatar.vala"
					if (!_tmp21_) {
#line 92 "../src/client/util/util-avatar.vala"
						break;
#line 614 "util-avatar.c"
					}
#line 93 "../src/client/util/util-avatar.vala"
					_tmp22_ = c;
#line 93 "../src/client/util/util-avatar.vala"
					if (g_unichar_isalnum (_tmp22_)) {
#line 620 "util-avatar.c"
						GString* _tmp23_;
						gunichar _tmp24_;
#line 94 "../src/client/util/util-avatar.vala"
						_tmp23_ = buf;
#line 94 "../src/client/util/util-avatar.vala"
						_tmp24_ = c;
#line 94 "../src/client/util/util-avatar.vala"
						g_string_append_unichar (_tmp23_, _tmp24_);
#line 95 "../src/client/util/util-avatar.vala"
						break;
#line 631 "util-avatar.c"
					}
				}
			}
		}
#line 99 "../src/client/util/util-avatar.vala"
		_tmp25_ = buf;
#line 99 "../src/client/util/util-avatar.vala"
		_tmp26_ = g_string_get_data (_tmp25_, &_tmp26__length1);
#line 99 "../src/client/util/util-avatar.vala"
		_tmp27_ = _tmp26_;
#line 99 "../src/client/util/util-avatar.vala"
		_tmp27__length1 = _tmp26__length1;
#line 99 "../src/client/util/util-avatar.vala"
		if (_tmp27__length1 > 0) {
#line 646 "util-avatar.c"
			GString* _tmp28_;
			guint8* _tmp29_;
			gint _tmp29__length1;
			guint8* _tmp30_;
			gint _tmp30__length1;
			gchar* _tmp31_;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp28_ = buf;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp29_ = g_string_get_data (_tmp28_, &_tmp29__length1);
#line 100 "../src/client/util/util-avatar.vala"
			_tmp30_ = _tmp29_;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp30__length1 = _tmp29__length1;
#line 100 "../src/client/util/util-avatar.vala"
			_tmp31_ = g_strdup ((const gchar*) _tmp30_);
#line 100 "../src/client/util/util-avatar.vala"
			_g_free0 (initials);
#line 100 "../src/client/util/util-avatar.vala"
			initials = _tmp31_;
#line 667 "util-avatar.c"
		}
#line 77 "../src/client/util/util-avatar.vala"
		_g_string_free0 (buf);
#line 671 "util-avatar.c"
	}
#line 103 "../src/client/util/util-avatar.vala"
	result = initials;
#line 103 "../src/client/util/util-avatar.vala"
	_g_free0 (normalized);
#line 103 "../src/client/util/util-avatar.vala"
	return result;
#line 679 "util-avatar.c"
}


void
util_avatar_get_color_for_name (const gchar* name,
                                GdkRGBA* result)
{
#line 109 "../src/client/util/util-avatar.vala"
	static const gdouble GNOME_COLOR_PALETTE[28][3] = {{(gdouble) 98, (gdouble) 160, (gdouble) 234}, {(gdouble) 53, (gdouble) 132, (gdouble) 228}, {(gdouble) 28, (gdouble) 113, (gdouble) 216}, {(gdouble) 26, (gdouble) 95, (gdouble) 180}, {(gdouble) 87, (gdouble) 227, (gdouble) 137}, {(gdouble) 51, (gdouble) 209, (gdouble) 122}, {(gdouble) 46, (gdouble) 194, (gdouble) 126}, {(gdouble) 38, (gdouble) 162, (gdouble) 105}, {(gdouble) 248, (gdouble) 228, (gdouble) 92}, {(gdouble) 246, (gdouble) 211, (gdouble) 45}, {(gdouble) 245, (gdouble) 194, (gdouble) 17}, {(gdouble) 229, (gdouble) 165, (gdouble) 10}, {(gdouble) 255, (gdouble) 163, (gdouble) 72}, {(gdouble) 255, (gdouble) 120, (gdouble) 0}, {(gdouble) 230, (gdouble) 97, (gdouble) 0}, {(gdouble) 198, (gdouble) 70, (gdouble) 0}, {(gdouble) 237, (gdouble) 51, (gdouble) 59}, {(gdouble) 224, (gdouble) 27, (gdouble) 36}, {(gdouble) 192, (gdouble) 28, (gdouble) 40}, {(gdouble) 165, (gdouble) 29, (gdouble) 45}, {(gdouble) 192, (gdouble) 97, (gdouble) 203}, {(gdouble) 163, (gdouble) 71, (gdouble) 186}, {(gdouble) 129, (gdouble) 61, (gdouble) 156}, {(gdouble) 97, (gdouble) 53, (gdouble) 131}, {(gdouble) 181, (gdouble) 131, (gdouble) 90}, {(gdouble) 152, (gdouble) 106, (gdouble) 68}, {(gdouble) 134, (gdouble) 94, (gdouble) 60}, {(gdouble) 99, (gdouble) 69, (gdouble) 44}};
#line 689 "util-avatar.c"
	GdkRGBA color = {0};
	GdkRGBA _tmp0_ = {0};
	guint hash = 0U;
	guint number_of_colors = 0U;
	guint idx = 0U;
	gint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	gdouble _tmp5_;
	guint _tmp6_;
	gdouble _tmp7_;
	guint _tmp8_;
	gdouble _tmp9_;
#line 107 "../src/client/util/util-avatar.vala"
	g_return_if_fail (name != NULL);
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.red = (gdouble) 255;
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.green = (gdouble) 255;
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.blue = (gdouble) 255;
#line 140 "../src/client/util/util-avatar.vala"
	_tmp0_.alpha = 1.0;
#line 140 "../src/client/util/util-avatar.vala"
	color = _tmp0_;
#line 145 "../src/client/util/util-avatar.vala"
	if (g_strcmp0 (name, "") == 0) {
#line 146 "../src/client/util/util-avatar.vala"
		*result = color;
#line 146 "../src/client/util/util-avatar.vala"
		return;
#line 722 "util-avatar.c"
	}
#line 149 "../src/client/util/util-avatar.vala"
	hash = g_str_hash (name);
#line 150 "../src/client/util/util-avatar.vala"
	_tmp1_ = G_N_ELEMENTS (GNOME_COLOR_PALETTE);
#line 150 "../src/client/util/util-avatar.vala"
	number_of_colors = (guint) _tmp1_;
#line 151 "../src/client/util/util-avatar.vala"
	_tmp2_ = hash;
#line 151 "../src/client/util/util-avatar.vala"
	_tmp3_ = number_of_colors;
#line 151 "../src/client/util/util-avatar.vala"
	idx = _tmp2_ % _tmp3_;
#line 153 "../src/client/util/util-avatar.vala"
	_tmp4_ = idx;
#line 153 "../src/client/util/util-avatar.vala"
	_tmp5_ = (*GNOME_COLOR_PALETTE)[(_tmp4_ * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 0];
#line 153 "../src/client/util/util-avatar.vala"
	color.red = _tmp5_;
#line 154 "../src/client/util/util-avatar.vala"
	_tmp6_ = idx;
#line 154 "../src/client/util/util-avatar.vala"
	_tmp7_ = (*GNOME_COLOR_PALETTE)[(_tmp6_ * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 1];
#line 154 "../src/client/util/util-avatar.vala"
	color.green = _tmp7_;
#line 155 "../src/client/util/util-avatar.vala"
	_tmp8_ = idx;
#line 155 "../src/client/util/util-avatar.vala"
	_tmp9_ = (*GNOME_COLOR_PALETTE)[(_tmp8_ * G_N_ELEMENTS (GNOME_COLOR_PALETTE[0])) + 2];
#line 155 "../src/client/util/util-avatar.vala"
	color.blue = _tmp9_;
#line 157 "../src/client/util/util-avatar.vala"
	*result = color;
#line 157 "../src/client/util/util-avatar.vala"
	return;
#line 758 "util-avatar.c"
}



